<?php
/*
Project name:	Meltdown BBS
File:		common.php
Version:	1.0 beta
Copyright:	(c) 2003-2004 Petko Bossakov
Email:		bossakov@mail.bg
WWW:		http://meltdown-bbs.sourceforge.net

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/

error_reporting (E_ALL ^ E_NOTICE);

include('config.php');

// Do some basic security checking

if (!defined('IN_MELTDOWN')){
	die("Security error: possible hacking attempt");
}
if(!defined("MELTDOWN_INSTALLED")){
	header("Location: install.php");
	exit;
}
if (file_exists('install.php')) {
	die("Security error: please delete install.php after installation is done.");
}

// It would be a nice gesture if you keep this copyright notice as it is,
// and also include it in any custom templates that you make. Thanks!
$powered_by = "Powered by: Meltdown BBS 1.0 beta, &copy; 2003-2004 Petko Bossakov";

// Connect to database
require('db.php');
$link = db_pconnect($DB_HOST, $DB_USER, $DB_PASS) or die(db_error($link));
db_select_db ($DB_NAME) or die (db_error($link));
define("LINK",$link);

// Fetch configuration options
$config = array();
$sql = "SELECT * FROM config";
$result = db_query($sql) or die(db_error(LINK));
while ( $row = db_fetch_assoc($result) ) {
	$config[$row['config_name']] = $row['config_value'];
}

// Initialize session
session_start();


// Get language options
$language = $_SESSION['language'];
if (empty($language)) $language = $config['language'];
include('language/' . $language . '.php');

// Initialize template engine
require('template.inc');
$tpl = new template;
$tpldir = $_SESSION['template'];
if ((empty($tpldir)) or (!is_dir("templates/$tpldir"))) $tpldir=$config['template'];

// Check template version
$handle = @fopen("templates/$tpldir/version", 'r');
if ($handle) {
	$tplver = fgets($handle, 5);
	fclose($handle);
	if ($config['version'] > intval($tplver)) echo('<b>Warning:</b> current HTML template is designed for an earlier version of Meltdown BBS. Please update your template.');
} else {
	echo('<b>Warning:</b> could not get the version of the current HTML template. It may be incompatible with this version of Meltdown BBS.');
}

$bbs_name = $config['bbs_name'];

// Check for session activity
if ($config['timeout'] > 0 && $_SESSION['timeout'] > 0) {
	if ((time() - $_SESSION['timeout'] > $config['timeout']) and ($_SESSION['userid'] > 0)) {
		$sql = "UPDATE users SET lastvisit='" . $_SESSION['timeout'] . "' WHERE firstname='" . $_SESSION['firstname'] . "' AND lastname='" . $_SESSION['lastname'] . "'";
		db_query($sql) or die(db_error(LINK));
		$_SESSION = array();
		session_destroy();

		$register_vars = array('l_timeout', 'l_timeout_info');
		language_process($register_vars);
		$tpl->pprint_file("templates/$tpldir/timeout.html", $register_vars);
		exit;
	} elseif($_SESSION['userid'] > 0) {
		$_SESSION['timeout'] = time();
	}
}

function template_options() {
// Returns a HTML <option> list of all available templates
	global $config;
	$template_options = '<select name="template">';
	$handle = opendir("templates");
        while (($file = readdir($handle)) !== false) {
		if (is_dir("templates/".$file) and ($file != ".") and ($file != "..")) {
			$template_options .= "\n<option" . (($file == $config['template'])?" selected ":" ") . "value=\"$file\">$file</option>";
		}
	}
	closedir($handle);
	$template_options .= "</select>";
	return $template_options;
}

function language_options() {
// Returns a HTML <option> list of all available languages
	global $config;
	$language_options = '<select name="language">';
	$handle = opendir("language");
        while (($file = readdir($handle)) !== false) {
		if (!is_dir($file) and (strpos(strtolower($file), ".php") == 2)) {
			$option = str_replace(".php", "", strtolower($file));
			$language_options .= "\n<option" . (($option == $config['language'])?" selected ":" ") . "value=\"$option\">$option</option>";
		}
	}
	closedir($handle);	
	$language_options .= "</select>";
	return $language_options;
}

function language_process(&$variables) {
	global $lang;
	foreach ($variables as $var) {
 		if (strpos($var, 'l_') === 0) {
			global $$var;
			$$var = $lang[substr($var,2)];
		}
	}
	$variables[] = 'bbs_name';
	$variables[] = 'powered_by';
	$variables[] = 'translation_info';
	$variables[] = 'nav';
	addnav();
}

function addnav() {
	global $lang, $nav;
	if (!empty($_SESSION['userid'])) {
		$nav = '[<a href="index.php">' . $lang['topnav_home'] . '</a>] ';
		$nav .= '[<a href="netmail.php">' . $lang['topnav_mail'] . '</a>] ';
		$nav .= '[<a href="echos.php">' . $lang['topnav_forums'] . '</a>] ';
		$nav .= '[<a href="areas.php">' . $lang['topnav_files'] . '</a>] ';
		$nav .= '[<a href="search.php">' . $lang['topnav_search'] . '</a>] ';
		$nav .= '[<a href="settings.php">' . $lang['topnav_settings'] . '</a>] ';
		$nav .= '[<a href="index.php?op=logout">' . $lang['topnav_logout'] . '</a>] ';
		if ($_SESSION['level'] >= 100) $nav .= '[<a href="admin/index.php">' . $lang['topnav_admin'] . '</a>] ';
	} else {
		$nav = '';
	}
}

function die_gracefully($message) {
// Uses templates to output error messages
	//The template engine only works with global variables
	global $tpl, $tpldir, $bbs_name, $l_error, $l_error_info, $error_message;
	$error_message = $message;
	$register_vars = array('error_message', 'l_error', 'l_error_info');
	language_process($register_vars);
        $tpl->pprint_file("templates/$tpldir/error.html", $register_vars);
	exit;
}


function validate_email($address) {
// Checks if email address is valid

// Is string empty?
if(empty($address)) return false;

// Does address contain "@"?
if(!ereg("@",$address)) return false;

// Check for user@host format
list($user,$host) = split("@",$address);
if ((empty($user)) or (empty($host))) return false;

// Check for whitespace in address
if( ereg("[ 	]",$address) ) return false;

// Only A-Z, 0-9, - and . are allowed in a hostname
$bad = eregi_replace("[-A-Z0-9\.]","",$host);
if(!empty($bad)) return false;

// Check for double dot in hostname
if(ereg("\.\.",$host)) return false;

// Check for leading dot in hostname
if(ereg("^\.",$host)) return false;

// Check for dot separator
$chunks = explode(".",$host);
$count = count($chunks) - 1;
if (gettype($chunks) != "array") return false;
if ($count < 1) return false;

// Check for valid TLD
$tld = $chunks[$count];

if(empty($tld)) return false;

$valid_tlds = array(
'com', 'net', 'org', 'edu', 'gov', 'biz', 
'info', 'mil', 'int', 'ac', 'ad', 'ae', 'af', 
'ag', 'ai', 'al', 'am', 'an', 'ao', 'aq', 'ar', 
'as', 'at', 'au', 'aw', 'az', 'ba', 'bb', 'bd', 
'be', 'bf', 'bg', 'bh', 'bi', 'bj', 'bm', 'bn', 
'bo', 'br', 'bs', 'bt', 'bv', 'bw', 'by', 'bz', 
'ca', 'cc', 'cd', 'cf', 'cg', 'ch', 'ci', 'ck', 
'cl', 'cm', 'cn', 'co', 'cr', 'cu', 'cv', 'cx', 
'cy', 'cz', 'de', 'dj', 'dk', 'dm', 'do', 'dz', 
'ec', 'ee', 'eg', 'eh', 'er', 'es', 'et', 'fi', 
'fj', 'fk', 'fm', 'fo', 'fr', 'ga', 'gd', 'ge', 
'gf', 'gg', 'gh', 'gi', 'gl', 'gm', 'gn', 'gp', 
'gq', 'gr', 'gs', 'gt', 'gu', 'gw', 'gy', 'hk', 
'hm', 'hn', 'hr', 'ht', 'hu', 'id', 'ie', 'il', 
'im', 'in', 'io', 'iq', 'ir', 'is', 'it', 'je', 
'jm', 'jo', 'jp', 'ke', 'kg', 'kh', 'ki', 'km', 
'kn', 'kp', 'kr', 'kw', 'ky', 'kz', 'la', 'lb', 
'lc', 'li', 'lk', 'lr', 'ls', 'lt', 'lu', 'lv', 
'ly', 'ma', 'mc', 'md', 'mg', 'mh', 'mk', 'ml', 
'mm', 'mn', 'mo', 'mp', 'mq', 'mr', 'ms', 'mt', 
'mu', 'mv', 'mw', 'mx', 'my', 'mz', 'na', 'nc', 
'ne', 'nf', 'ng', 'ni', 'nl', 'no', 'np', 'nr', 
'nu', 'nz', 'om', 'pa', 'pe', 'pf', 'pg', 'ph', 
'pk', 'pl', 'pm', 'pn', 'pr', 'ps', 'pt', 'pw', 
'py', 'qa', 're', 'ro', 'ru', 'rw', 'sa', 'sb', 
'sc', 'sd', 'se', 'sg', 'sh', 'si', 'sj', 'sk', 
'sl', 'sm', 'sn', 'so', 'sr', 'st', 'sv', 'sy', 
'sz', 'tc', 'td', 'tf', 'tg', 'th', 'tj', 'tk', 
'tm', 'tn', 'to', 'tp', 'tr', 'tt', 'tv', 'tw', 
'tz', 'ua', 'ug', 'uk', 'um', 'us', 'uy', 'uz', 
'va', 'vc', 've', 'vg', 'vi', 'vn', 'vu', 'wf', 
'ws', 'ye', 'yt', 'yu', 'za', 'zm', 'zr', 'zw'
);

foreach($valid_tlds as $valid_tld) {
	if ($tld == $valid_tld) {
		unset($valid_tlds);
		return true;
	}
}
unset($valid_tlds);
return false;
}

function validate_node($node) {
	list($zonenet, $node) = explode("/", $node);
	list($zone, $net) = explode(":", $zonenet);
	if (($zone == 0) or ($net == 0) or ($node == '')) {
		return false;
	} else {
		return true;
	}
}

?>