<?php
/*
Project name:	Meltdown BBS
File:		files.php
Version:	1.0 beta
Copyright:	(c) 2003-2004 Petko Bossakov
Email:		bossakov@mail.bg
WWW:		http://meltdown-bbs.sourceforge.net

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/

define('IN_MELTDOWN', true);
require('common.php');

if (empty($_SESSION['userid'])) {
	header('Location: index.php');
	exit;
}

if ($_GET['op'] == 'delete') {
	$fileid = $_GET['fileid'];
	if (empty($fileid)) die_gracefully('This file does not exist');

	$sql = "SELECT * FROM files WHERE fileid='$fileid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This file does not exist');
	$f = db_fetch_assoc($result);

	// Check if we have admin privileges for this area
	$sql = "SELECT areaid, path, level_admin FROM areas WHERE areaid='" . $f['areaid'] . "'";
	$result = db_query($sql) or die(db_error(LINK));
	$area = db_fetch_assoc($result);
	if ($area['level_admin'] > $_SESSION['level']) die_gracefully('You cannot delete this file - access level too low');

	// Fine, kill that poor, defenseless file!
	$sql = "DELETE FROM files WHERE fileid = '$fileid'";
	db_query($sql) or die(db_error(LINK));
	$fullpath = $area['path'] . '/' . $f['filename'];
	if (file_exists($fullpath)) unlink($fullpath);

	header("Location: files.php?areaid=" . $area['areaid']);	
}
elseif ($_GET['op'] == 'edit') {
	$fileid = $_GET['fileid'];
	if (empty($fileid)) die_gracefully('This file does not exist');

	$sql = "SELECT * FROM files WHERE fileid='$fileid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This file does not exist');
	$f = db_fetch_assoc($result);

	// Check if we have admin privileges for this area
	$sql = "SELECT areaid, path, level_admin FROM areas WHERE areaid='" . $f['areaid'] . "'";
	$result = db_query($sql) or die(db_error(LINK));
	$area = db_fetch_assoc($result);
	if ($area['level_admin'] > $_SESSION['level']) die_gracefully('You cannot edit this file - access level too low');

	// Get a list of possible areas
	$arealist = '';
	$sql = "SELECT * FROM areas WHERE level_admin <= '" . $_SESSION['level'] . "'";
	$result = db_query($sql) or die(db_error(LINK));
	
	while ($row = db_fetch_assoc($result)){
		$arealist .= 
			'<option' . 
			(($row['areaid'] == $area['areaid']) ? ' selected ' : ' ') . 
			'value="'. $row['areaid'] . '">' . 
			$row['name'] . '</option>\r\n';
	}

	// Now output edit form
	$filename = $f['filename'];
	$description = $f['description'];
	$mime_type = $f['mime_type'];
	$dl = $f['downloads'];	

	$register_vars = array(
		'l_edit_file', 'l_filename', 'l_description', 'l_filearea',
		'l_num_downloads', 'filename', 'description', 'arealist', 'l_save',
		'mime_type', 'dl', 'fileid'
	);

	language_process($register_vars);

	$tpl->pprint_file("templates/$tpldir/editfile.html", $register_vars);
}
elseif ($_POST['op'] == 'edit') {
	$postvars = array('fileid', 'filename', 'description', 'area', 'mimetype');
	foreach ($postvars as $var) {
		if (!empty($_POST[$var])) {
			$$var=htmlspecialchars($_POST[$var]);
		} else {
			die_gracefully("$var not entered");
		}
	}
	$downloads = $_POST['downloads'];

	$sql = "SELECT * FROM files WHERE fileid='$fileid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This file does not exist');
	$f = db_fetch_assoc($result);

	// Check if we have admin privileges for both the old and new areaa
	$sql = "SELECT areaid, path, level_admin FROM areas WHERE areaid='" . $f['areaid'] . "'";
	$result = db_query($sql) or die(db_error(LINK));
	$area1 = db_fetch_assoc($result);
	if ($area1['level_admin'] > $_SESSION['level']) die_gracefully('You cannot edit this file - access level too low');

	$sql = "SELECT areaid, path, level_admin FROM areas WHERE areaid='$area'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This area does not exist');
	$area2 = db_fetch_assoc($result);
	if ($area2['level_admin'] > $_SESSION['level']) die_gracefully('You cannot edit this file - access level for destination area too low');


	// If name has changed, also rename file
	$oldfullname = $area1['path'] . '/' . $f['filename'];
	$newfullname = $area2['path'] . '/' . $filename;
	if ($oldfullname != $newfullname) {
		rename($oldfullname, $newfullname) or die('Could not rename file');
	}

	$sql = "UPDATE files SET filename='$filename', description='$description', areaid='$area', mime_type='$mimetype', downloads='$downloads' WHERE fileid='$fileid'";
	db_query($sql) or die(db_error(LINK));

	header("Location: files.php?areaid=$area");
}
else {
	$areaid = $_GET['areaid'];
	if (empty($areaid)) die_gracefully('This file area does not exist');

	switch($_GET['orderby']) {
		case 1:
			$orderby = 'filename';
			break;
		case 2:
			$orderby = 'description';
			break;
		case 3:
			$orderby = 'upload_time DESC';
			break;
		case 4:
			$orderby = 'downloads DESC';
			break;
		case 5:
			$orderby = 'uploader_id';
			break;
		default:
			$orderby = 'filename';
	}

	// Check if we have list privileges for this area
	$sql = "SELECT * FROM areas WHERE areaid='$areaid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This file area does not exist');
	$area = db_fetch_assoc($result);
	if ($area['level_list'] > $_SESSION['level']) die_gracefully('You have no access to this file area');

	// How about admin rights?
	if ($area['level_admin'] <= $_SESSION['level']) {
		$admin_privs = true;
	} else {
		$admin_privs = false;
	}

	// And upload rights?
	if ($area['level_upload'] <= $_SESSION['level']) {
		$upload_rights = true;
	} else {
		$upload_rights = false;
	}

	// Get list of files
	$sql = "SELECT * FROM files WHERE areaid='$areaid' ORDER BY $orderby";
	$result = db_query($sql) or die(db_error(LINK));
	$filelist = array();	
	$sizesotr = array();
	$i = -1;

	while ($row = db_fetch_assoc($result)){

		// Get uploader's name
		$sql = "SELECT firstname, lastname FROM users WHERE userid='" . $row['uploader_id'] . "'";
		$res2 = db_query($sql) or die(db_error(LINK));
		$uploader = db_fetch_assoc($res2);

		if (file_exists($area['path'] . '/' . $row['filename'])) {

			$size = filesize($area['path'] . '/' . $row['filename']);
			// Does user want to order by size?
			if ($_GET['orderby'] == 6) {
				$i++;
				$sizesort[$i] = $size;
			}
			if ($size > 1048576) {
				$size = round($size / 1048576, 2) . ' MB';
			}
			elseif ($size > 1023) {
				$size = round($size / 1024) . 'k';
			}

			$filelist[] = array(
				'filename' => $row['filename'],
				'filesize' => $size,
				'description' => $row['description'],
				'date' => date('j.n.Y', $row['upload_time']),
				'downloads' => $row['downloads'],
				'uploader' => $uploader['firstname'] . ' ' . $uploader['lastname'],
				'fileid' => $row['fileid'],
				'admin_functions' => $admin_privs ? 
					'<a href="files.php?op=edit&fileid=' . $row['fileid'] . '"><img src="templates/' . $tpldir . '/images/edit.gif" width="16" height="16"></a>'
					. '<a href="files.php?op=delete&fileid=' . $row['fileid'] . '" onClick="return confirm(\'Delete file ' . $row['filename'] . '?\')"><img src="templates/' . $tpldir . '/images/del.gif" width="16" height="16"></a>'
					: '',
			);
		}

	}

	// Does user want to order by size?
	if ($_GET['orderby'] == 6) {
		$newlist = array();
		asort($sizesort);
		foreach ($sizesort as $key => $value) {
			$newlist[] = $filelist[$key];
		}
		$filelist = $newlist;
	}

	// Output results
	$area_name = $area['name'];
	$area_description = $area['description'];
	$maxsize = ini_get('upload_max_filesize');
	$register_vars = array(
		'area_name', 'area_description', 'l_filename', 'l_filesize', 'l_description',
		'l_date', 'l_num_downloads', 'l_uploader', 'l_upload_file', 'l_submit',
		'areaid', 'maxsize'
	);
	language_process($register_vars);

	$tpl->load_file('files-list', "templates/$tpldir/files-list.html");
	$tpl->parse_loop('files-list', 'filelist');
	$tpl->parse_if('files-list', 'upload_rights');
	$tpl->pprint('files-list', $register_vars);
}

?>