<?php
/*
Project name:	Meltdown BBS
File:		netmail.php
Version:	1.0 beta
Copyright:	(c) 2003-2004 Petko Bossakov
Email:		bossakov@mail.bg
WWW:		http://meltdown-bbs.sourceforge.net

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/

define('IN_MELTDOWN', true);
require('common.php');

if (empty($_SESSION['userid'])) {
	header('Location: ../index.php');
	exit;
}

if ($_GET['op'] == 'delete') {
	$msgid = $_GET['msgid'];
	if (empty($msgid)) die_gracefully('This message does not exist');
	$sql = "SELECT * FROM netmail WHERE msgid='$msgid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This message does not exist');
	$msg = db_fetch_assoc($result);
	if (($msg['recipient'] != $_SESSION['firstname'] . ' ' . $_SESSION['lastname']) and ($_SESSION['level'] < 100)) die_gracefully('You cannot delete this message.');

	$sql = "DELETE FROM netmail WHERE msgid='$msgid'";
	db_query($sql) or die(db_error(LINK));
	header('Location: netmail.php');	
}
elseif ($_GET['op'] == 'read') {
	$msgid = $_GET['msgid'];
	if (empty($msgid)) die_gracefully('This message does not exist');
	$sql = "SELECT * FROM netmail WHERE msgid='$msgid'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) < 1) die_gracefully('This message does not exist');
	$msg = db_fetch_assoc($result);
	if (($msg['recipient'] != $_SESSION['firstname'] . ' ' . $_SESSION['lastname']) and ($_SESSION['level'] < 100)) die_gracefully('You cannot read this message.');

	if (!empty($msg['sourcenode'])) {
		$from_node = $msg['sourcenode'];
		$fidonet = true;
	} else {
		$fidonet = false;
	}
	$date = date('j.n.Y', $msg['datetime']);
	$from = $msg['sender'];
	$subject = $msg['subject'];
	$body = str_replace("\r", '', $msg['body']);
	$body = wordwrap($body, 80, "\n");
	$body = str_replace("\n", "<br>\r\n", $body);
	$body_quoted = $msg['sender'] . " wrote:\n" . "> " . str_replace("\n", "\n> ", wordwrap($msg['body'], 70, "\n")) . "\n\n";
	if (strpos(strtolower($subject), 're:') === 0) {
		$subject_reply = $subject;
	} else {
		$subject_reply = 'Re: ' . $subject;
	}

	$register_vars = array(
		'msgid', 'l_op_del', 'from', 'subject', 'date',
		'l_from', 'l_subject', 'l_date', 'l_sendreply',
		'subject_reply', 'body_quoted', 'l_send', 'body', 'l_to', 'l_inbox',
		'from_node', 'l_from_node'
	);
	language_process($register_vars);

	$tpl->load_file('read', "templates/$tpldir/netmail-read.html");
	$tpl->parse_if('read', 'fidonet');
	$tpl->pprint('read', $register_vars);
}
elseif ($_GET['op'] == 'send') {
	if (!empty($config['nodenumber'])) {
		$fidonet = true;
	} else {
		$fidonet = false;
	}

	$register_vars = array(
		'l_sendnew', 'l_to', 'l_subject', 'l_send',
		'l_msgtype', 'l_msgtype_local', 'l_msgtype_fidonet', 'l_destination_node'
	);
	language_process($register_vars);

	$tpl->load_file('send', "templates/$tpldir/netmail-send.html");
	$tpl->parse_loop('send', 'table_rows');
	$tpl->parse_if('send', 'fidonet');
	$tpl->pprint('send', $register_vars);
}
elseif ($_POST['op'] == 'send') {
	$fido = 0;
	$destination_node ='';
	$destnode = '';
	$postvars = array('to', 'subject', 'body');
	if (!empty($config['nodenumber'])) $postvars[] = 'fido';
	foreach ($postvars as $var) {
		if (!empty($_POST[$var])) {
			$$var=htmlspecialchars($_POST[$var]);
		} else {
			die_gracefully("$var not entered");
		}
	}
	if ($fido == 1) {
		$destination_node = ", '" . $_POST['node'] . "'";
		if (empty($destination_node)) die_gracefully('Fidonet address not set');
		if (!validate_node($_POST['node'])) die_gracefully('Invalid Fidonet address entered');
		$destnode = ', destnode';
	} else {
		// Check if local user exists
		list($first, $last) = explode(" ", $to);
		$sql = "SELECT * FROM users WHERE firstname='$first' AND lastname='$last'";
		$result = db_query($sql) or die(db_error(LINK));
		if (db_num_rows($result) < 1) die_gracefully('The user you specified is not registered on this BBS.');
	}

	$body = str_replace('\r', '', $body);
	$body = str_replace('\n', '\\r\\n', $body);

	$sql = "INSERT INTO netmail (sender, recipient, subject, datetime, body $destnode) VALUES ('" . $_SESSION['firstname'] . " " . $_SESSION['lastname'] . "', '$to', '$subject', '" . time() . "', '$body' $destination_node)";
	db_query($sql) or die(db_error(LINK));
	header("Location: netmail.php");
}
else {
	// Check user's inbox
	$sql = "SELECT * FROM netmail WHERE recipient = '" . $_SESSION['firstname'] . " " . $_SESSION['lastname'] . "'";
	if ($_SESSION['level'] >= 100) $sql .= " OR recipient = 'Sysop'";
	$sql .= " ORDER BY datetime DESC";
	$result = db_query($sql) or die(db_error(LINK));
	$table_rows = array();
	$i=-1;
	while ($row = db_fetch_assoc($result)){
		$i++;
		$table_rows[$i] = array(
			'date' => date('j.n.Y', $row['datetime']),
			'sender' => $row['sender'],
			'subject' => $row['subject'],
			'msgid' => $row['msgid']
		);
		if ($row['datetime'] > $_SESSION['lastvisit']) $table_rows[$i]['date'] = '<b>' . $table_rows[$i]['date'] . '</b>';
	}

	$register_vars = array('l_inbox', 'l_sendnew', 'l_date', 'l_from', 'l_subject');
	language_process($register_vars);

	$tpl->load_file('inbox', "templates/$tpldir/netmail-inbox.html");
	$tpl->parse_loop('inbox', 'table_rows');
	$tpl->pprint('inbox', $register_vars);

}
?>