<?php
/*
Project name:	Meltdown BBS
File:		register.php
Version:	1.0 beta
Copyright:	(c) 2003-2004 Petko Bossakov
Email:		bossakov@mail.bg
WWW:		http://meltdown-bbs.sourceforge.net

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/

define('IN_MELTDOWN', true);
require('common.php');

if ($_POST['op'] == 'register') {
	$postvars=array('firstname', 'lastname', 'password', 'pw2', 'language', 'template', 'email');
	foreach ($postvars as $var) {
		if (!empty($_POST[$var])) {
			$$var=htmlspecialchars($_POST[$var]);
		} else {
			die_gracefully("$var not entered");
		}
	}
	$level = $config['newuser_level'];
	if (strlen($password) < 4) die_gracefully('Your password should be at least 4 characters long.');
	if ($password != $pw2) die_gracefully('Passwords do not match.');
	if (!is_dir("templates/$template")) die_gracefully('Selected template is not installed on this system.');
	if (!file_exists("language/" . $language . ".php")) die_gracefully('Selected language is not installed on this system.');
	if (!validate_email($email)) die_gracefully('Please enter a valid email address!');
	$sql = "SELECT * FROM users WHERE firstname = '$firstname' and lastname = '$lastname'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) >= 1){
		die_gracefully("Sorry, a user named $firstname $lastname already exists on this system.");
	}
	$sql = "SELECT * FROM users WHERE email = '$email'";
	$result = db_query($sql) or die(db_error(LINK));
	if (db_num_rows($result) >= 1){
		die_gracefully("Sorry, a user with the email address \"$email\" already exists on this system.");
	}
	
	// Now that we have validated all the input, let's create the user...
	$sql = "INSERT INTO users (level, firstname, lastname, password, email, regdate, lastvisit, language, template, uploads) VALUES ('$level', '$firstname', '$lastname', '" . md5($password) . "', '$email', '" . time() . "', '" . time() . "', '$language', '$template', '" . $config['newuser_uploads'] . "');";
	db_query($sql) or die(db_error(LINK));

	// Send a notification to the sysop(s)...
	$sql = "SELECT firstname, lastname FROM users WHERE level > 99";
	$result = db_query($sql) or die(db_error(LINK));
	while ($row = db_fetch_assoc($result)) {
		$sql = "INSERT INTO netmail (sender, recipient, subject, datetime, body) VALUES ('System', '" . $row['firstname'] . " " . $row['lastname'] . "', 'New user notification', '" . time() . "', 'New user ($firstname $lastname) registered on " . date('j.n.Y, G:i') . "')";
		db_query($sql) or die(db_error(LINK));
	}
	
	// Yipee, they're registered! Now tell them the good news...
	$register_vars = array('l_registered', 'l_congrats', 'l_registered_info', 'l_registered_security', 'firstname', 'lastname', 'level');
	language_process($register_vars);
        $tpl->pprint_file("templates/$tpldir/register2.html", $register_vars);

} else {

	$options_language = language_options();
	$options_template = template_options();
	$register_vars = array(
		'l_newuser','l_newuser_info', 'l_firstname', 'l_lastname',
		'l_password', 'l_pw2', 'l_language', 'l_template',
		'l_submit', 'options_language', 'options_template',
		'l_email');
	language_process($register_vars);
        $tpl->pprint_file("templates/$tpldir/register.html", $register_vars);
}
?>