<?php
/*
Project name:	Meltdown BBS
File:		search.php
Version:	1.0 beta
Copyright:	(c) 2003-2004 Petko Bossakov
Email:		bossakov@mail.bg
WWW:		http://meltdown-bbs.sourceforge.net

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/

define('IN_MELTDOWN', true);
require('common.php');

if (empty($_SESSION['userid'])) {
	header('Location: index.php');
	exit;
}

if($_POST['op'] == 'search') {
	$postvars = array('searchfor', 'text');
	foreach ($postvars as $var) {
		if (!empty($_POST[$var])) {
			$$var=htmlspecialchars($_POST[$var]);
		} else {
			die_gracefully("$var not entered");
		}
	}

	// What are we going to search for?
	switch($searchfor) {
		case 1:
			$table_rows = array();	
			$sql = "SELECT * FROM msgs WHERE MATCH (subject,body) AGAINST ('$text') ORDER BY echoid, datetime DESC";
			$result = db_query($sql) or die(db_error(LINK));
			while ($row = db_fetch_assoc($result)){
				$sender = $row['sender'];
				$recipient = $row['recipient'];
				// Highlight user's own messages
				if ($sender == $_SESSION['firstname'] . ' ' . $_SESSION['lastname']) $sender = '<b>' . $sender . '</b>';
				if ($recipient == $_SESSION['firstname'] . ' ' . $_SESSION['lastname']) $recipient = '<b>' . $recipient . '</b>';

				// Get forum name
				$sql = "SELECT name, level_read FROM echos WHERE echoid='" . $row['echoid'] . "'";
				$result2 = db_query($sql) or die(db_error(LINK));
				$echo = db_fetch_assoc($result2);

				// Do we have access?
				if ($echo['level_read'] <= $_SESSION['level']) {
					$table_rows[] = array(
						'date' => date('j.n.Y', $row['datetime']),
						'sender' => $sender,
						'recipient' => $recipient,
						'subject' => $row['subject'],
						'msgid' => $row['msgid'],
						'forum' => $echo['name']
					);
				}
			}

			$register_vars = array(
				'l_search_results', 'l_forum', 'l_date',
				'l_subject', 'l_from', 'l_to'
			);
			language_process($register_vars);

			$tpl->load_file('search-results', "templates/$tpldir/search-results-msgs.html");
			$tpl->parse_loop('search-results', 'table_rows');
			$tpl->pprint('search-results', $register_vars);
			break;
		case 2:
			$table_rows = array();	
			$sql = "SELECT * FROM files WHERE filename = '$text' ORDER BY areaid, upload_time DESC";
			$result = db_query($sql) or die(db_error(LINK));
			while ($row = db_fetch_assoc($result)){
				// Get uploader's name
				$sql = "SELECT firstname, lastname FROM users WHERE userid='" . $row['uploader_id'] . "'";
				$result2 = db_query($sql) or die(db_error(LINK));
				$uploader = db_fetch_assoc($result2);
				
				// Get area name
				$sql = "SELECT name, level_list FROM areas WHERE areaid='" . $row['areaid'] . "'";
				$result2 = db_query($sql) or die(db_error(LINK));
				$area = db_fetch_assoc($result2);

				// Do we have access?
				if ($echo['level_read'] <= $_SESSION['level']) {
					$table_rows[] = array(
						'date' => date('j.n.Y', $row['upload_time']),
						'uploader' => $uploader['firstname'] . ' ' . $uploader['lastname'],
						'description' => $row['description'],
						'filename' => $row['filename'],
						'num_downloads' => $row['downloads'],
						'areaid' => $row['areaid'],
						'area' => $area['name'],
						'fileid' => $row['fileid']
					);
				}
				
			}

			$register_vars = array(
				'l_search_results', 'l_area', 'l_filename', 'l_date',
				'l_description', 'l_num_downloads', 'l_uploader'
			);

			language_process($register_vars);

			$tpl->load_file('search-results', "templates/$tpldir/search-results-files.html");
			$tpl->parse_loop('search-results', 'table_rows');
			$tpl->pprint('search-results', $register_vars);

			break;
		case 3:
			$table_rows = array();	
			$sql = "SELECT * FROM files WHERE MATCH (description) AGAINST ('$text') ORDER BY areaid, upload_time DESC";
			$result = db_query($sql) or die(db_error(LINK));
			while ($row = db_fetch_assoc($result)){
				// Get uploader's name
				$sql = "SELECT firstname, lastname FROM users WHERE userid='" . $row['uploader_id'] . "'";
				$result2 = db_query($sql) or die(db_error(LINK));
				$uploader = db_fetch_assoc($result2);
				
				// Get area name
				$sql = "SELECT name, level_list FROM areas WHERE areaid='" . $row['areaid'] . "'";
				$result2 = db_query($sql) or die(db_error(LINK));
				$area = db_fetch_assoc($result2);

				// Do we have access?
				if ($echo['level_read'] <= $_SESSION['level']) {
					$table_rows[] = array(
						'date' => date('j.n.Y', $row['upload_time']),
						'uploader' => $uploader['firstname'] . ' ' . $uploader['lastname'],
						'description' => $row['description'],
						'filename' => $row['filename'],
						'num_downloads' => $row['downloads'],
						'areaid' => $row['areaid'],
						'area' => $area['name'],
						'fileid' => $row['fileid']
					);
				}
				
			}

			$register_vars = array(
				'l_search_results', 'l_area', 'l_filename', 'l_date',
				'l_description', 'l_num_downloads', 'l_uploader'
			);

			language_process($register_vars);

			$tpl->load_file('search-results', "templates/$tpldir/search-results-files.html");
			$tpl->parse_loop('search-results', 'table_rows');
			$tpl->pprint('search-results', $register_vars);

			break;
		default:
			header('Location: search.php');
	}
}
else {
	$register_vars = array(
		'l_search_for', 'l_searchfor_msg', 'l_searchfor_filename',
		'l_searchfor_filedesc', 'l_text_to_find', 'l_search'
	);
	language_process($register_vars);
	$tpl->pprint_file("templates/$tpldir/search.html", $register_vars);
}

?>